﻿#------------------------------------------------->
# JEliza Module
#
#-> name: Semantic
#-> compatible: 2.4
#-> author: JEliza Team
#-> copyright: Tobias Schulz
#-> date: 09.2007
#-------------------------------------------------->

# librarys to import
from defs import get_lang, contains
import modules.init_semantic
from modules.init_semantic import Entity, Relation, Fact, GetIsA, nouns, verbs, noun_verb, isa, nothing, getUniqValues, split_sentence, actualNet, initNet, semantic_loadcache, genNet, divide, formuliere, getSubjekte, getObjekte, getAdvBest, stimmt_spo, acc, add_sentence_to_net, get_list_subs, get_to_do, get_warum_to_do, formuliere
import string
import random
from modules.utilities import download_weather
from modules.semnet import acc_int
from jelizacpp import log
import time

tostr = str


# main part



fp = open("lang_" + get_lang() + "/wsh/arts.wsh", "r")
artikel = fp.read().strip().lower().replace("\n", " ").replace("  ", " ").split(" ")
fp.close()
fp = open("lang_" + get_lang() + "/wsh/preps.wsh", "r")
praepositions = fp.read().strip().lower().replace("\n", " ").replace("  ", " ").split(" ")
fp.close()

def make_better(question):
    _fra = question.strip().split(" ")
    fra = [ "" ]

    for f in _fra:
        if is_similar("." + f, ".ein") and fra[len(fra)-1] == "nicht":
            fra[len(fra)-1] = "k" + f
            continue
        if cpp_detect_wordtype(f) == 6 and fra[len(fra)-1] == "nicht":
            fra[len(fra)-1] = "kein"
            continue



        fra.append(f)

    question = " ".join(fra).strip()
    return question

def answer_logical_question_without_questionword(question, orig_fra, dbs):
    log("")
    log("S-N: question ohne questionwort!")
    log("")

    proz = 2.0

    for part in dbs.parts:
        log("part: " + str(part))

    opinion = []

    if len(dbs.parts) == 0:
        return ""

    subj = dbs.parts[0]

    verb = dbs.verb

    proz += 1
    apply_procent(proz)
    for part in dbs.parts[1:] + [""]:
        proz += 1
        apply_procent(proz)
        if stimmt_spo(subj, verb, part):
            pre = "Ja, "

            aaadvs = dbs.advs * 10 + getAdvBest(subj, dbs.verb)
            for adv1 in aaadvs:
                proz += 1
                apply_procent(proz)
                opinion.append(pre + formuliere(subj, dbs.verb, [part], [adv1], get_list_subs(dbs.parts[0], str(dbs.verb))))
            opinion.append(pre + formuliere(subj, dbs.verb, [part], [], get_list_subs(dbs.parts[0], str(dbs.verb))))
    if len(opinion) == 0:
        try:
            opinion.append("Nein, " + formuliere(subj, dbs.verb, dbs.parts[1:], ["nicht"] + getAdvBest(subj, dbs.verb), get_list_subs(dbs.parts[0], str(dbs.verb))))
        except KeyError:
            return ""

    # Zeige alle opinion
    for meinung in getUniqValues(opinion):
        log("S-N: - " + meinung)

    # Zufallsmeinung
    random.shuffle(opinion)

    # Rueckgabe: Meinung
    return opinion[0]

def answer_logical_questionword(question, orig_fra, dbs):
    proz = 2.0
    proz += 1
    apply_procent(proz)

    log("")
    log("S-N: question mit questionwort!")
    log("")

    for part in dbs.parts:
        log("part__: " + str(part))

    opinion = []

    if len(dbs.parts) == 0:
        return ""

    subj = dbs.parts[0]

    tmp_advs = [ x for x in [ p[1].lower() for p in dbs.parts ] + dbs.advs if len(x.strip()) ]

    if dbs.quesword.lower() == "wie" or dbs.quesword.lower() == "how":
        opinion += get_to_do(dbs)

    if dbs.quesword.lower() == "warum" or dbs.quesword.lower() == "wieso" or dbs.quesword.lower() == "weshalb" or dbs.quesword.lower() == "why":
        opinion += get_warum_to_do(dbs)

    if len(opinion):
        random.shuffle(opinion)
        # Rueckgabe: Meinung
        return opinion[0]

    print "Subjects..."

    known_all = [ p[1].split("|") for p in getObjekte(subj, dbs.verb) if p[0] != 100 ]
    known_best = [ p[1].split("|") for p in getObjekte(subj, dbs.verb) if p[0] == 100 ]
    print "getObjekte(subj, dbs.verb):", getObjekte(subj, dbs.verb)
    print "tmp_advs:", tmp_advs

    k1 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) ]
    print "k1:", k1
    k2 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) ]
    print "k2:", k2
    k3 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
    print "k3:", k3
    k4 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
    print "k4:", k4
    k5 = [ part for part in known_best ]
    print "k5:", k5
    k6 = [ part for part in known_all ]
    print "k6:", k6
    k7 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
    print "k7:", k7
    k8 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
    print "k8:", k8
    k9 = [ part for part in known_best if not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
    print "k9:", k9
    k10 = [ part for part in known_all if not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
    print "k10:", k10
    for part in known_best + known_all:
        print ":", " ".join(part + getAdvBest(part, dbs.verb)).lower()
    k11 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
    print "k11:", k11
    k12 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
    print "k12:", k12
    k13 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
    print "k13:", k13
    k14 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
    print "k14:", k14

    parts_known = []
    if not len(parts_known) and (dbs.quesword.lower() in ("wie", "how")):
        parts_known = k3[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("wie", "how")):
        parts_known = k4[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
        parts_known = k11[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
        parts_known = k12[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
        parts_known = k13[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
        parts_known = k14[:]

    if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
        parts_known = k7[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
        parts_known = k8[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
        parts_known = k9[:]
    if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
        parts_known = k10[:]

    if not len(parts_known):
        parts_known = k1[:]
    if not len(parts_known):
        parts_known = k2[:]
    if not len(parts_known):
        parts_known = k5[:]
    if not len(parts_known):
        parts_known = k6[:]


    parts_to_say = parts_known[:]

    proz += 1
    apply_procent(proz)

    print len(parts_to_say), len(parts_known)

    for part in parts_known:
        log("parts_known: " + str(part))


    for x in xrange(1,4):
        proz += 1
        apply_procent(proz)
        for part in parts_to_say:
            proz += 1
            apply_procent(proz)
            aaadvs = getAdvBest(subj, dbs.verb) + getAdvBest(part, dbs.verb)
            for adv1 in aaadvs:
                opinion.append(formuliere(subj, dbs.verb, [part], [adv1], get_list_subs(dbs.parts[0], str(dbs.verb))))
            if len(aaadvs) == 0:
                opinion.append(formuliere(subj, dbs.verb, [part], [], get_list_subs(dbs.parts[0], str(dbs.verb))))

    try:
        if acc(nouns, dbs.parts[0], False):
            if len(get_list_subs(dbs.parts[0], str(dbs.verb))) > 0 and len(opinion) == 0:
                opinion.append(formuliere(subj, dbs.verb, [], getAdvBest(subj, dbs.verb), get_list_subs(dbs.parts[0], str(dbs.verb))))
    except KeyError:
        pass



    print "Objects..."

    if not len(opinion):
        for subj in dbs.parts[1:]:
            if contains(subj, "nothing"):
                continue
            print "subj:", subj

            proz += 1
            apply_procent(proz)

            known_all = [ p[1].split("|") for p in getSubjekte(subj, dbs.verb) if p[0] != 100 ]
            known_best = [ p[1].split("|") for p in getSubjekte(subj, dbs.verb) if p[0] == 100 ]
            print "getObjekte(subj, dbs.verb):", getObjekte(subj, dbs.verb)
            print "tmp_advs:", tmp_advs

            k1 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) ]
            print "k1:", k1
            k2 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) ]
            print "k2:", k2
            k3 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
            print "k3:", k3
            k4 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
            print "k4:", k4
            k5 = [ part for part in known_best ]
            print "k5:", k5
            k6 = [ part for part in known_all ]
            print "k6:", k6
            k7 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
            print "k7:", k7
            k8 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
            print "k8:", k8
            k9 = [ part for part in known_best if not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
            print "k9:", k9
            k10 = [ part for part in known_all if not contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "nothing") ]
            print "k10:", k10
            for part in known_best + known_all:
                print ":", " ".join(part + getAdvBest(part, dbs.verb)).lower()
            k11 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
            print "k11:", k11
            k12 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
            print "k12:", k12
            k13 = [ part for part in known_best if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
            print "k13:", k13
            k14 = [ part for part in known_all if (is_similar_in_array(part[0], tmp_advs) or is_similar_in_array(part[1] + " ".join(getAdvBest(part, dbs.verb)), tmp_advs) or not len(tmp_advs)) and (contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "in ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "at ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "an ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "am ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "auf ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "unter ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "neben ") or contains(" ".join(part + getAdvBest(part, dbs.verb)).lower(), "im ")) ]
            print "k14:", k14

            parts_known = []
            if not len(parts_known) and (dbs.quesword.lower() in ("wie", "how")):
                parts_known = k3[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("wie", "how")):
                parts_known = k4[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
                parts_known = k11[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
                parts_known = k12[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
                parts_known = k13[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("where", "wo")):
                parts_known = k14[:]

            if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
                parts_known = k7[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
                parts_known = k8[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
                parts_known = k9[:]
            if not len(parts_known) and (dbs.quesword.lower() in ("wer", "who", "whom", "was", "what")):
                parts_known = k10[:]

            if not len(parts_known):
                parts_known = k1[:]
            if not len(parts_known):
                parts_known = k2[:]
            if not len(parts_known):
                parts_known = k5[:]
            if not len(parts_known):
                parts_known = k6[:]
            parts_to_say = parts_known[:]

            print len(parts_to_say), len(parts_known)

            for part in parts_to_say:
                proz += 1
                apply_procent(proz)
                if not is_similar(part, subj):
                    aaadvs = getAdvBest(subj, dbs.verb)
                    for adv1 in aaadvs:
                        if not is_similar(part, adv1) and not is_similar(subj, adv1):
                            proz += 0.5
                            apply_procent(proz)
                            opinion.append(formuliere([part, ""], dbs.verb, [subj], [adv1], get_list_subs(dbs.parts[0], str(dbs.verb))))
                    if len(aaadvs) == 0:
                        opinion.append(formuliere([part, ""], dbs.verb, [subj], [], get_list_subs(dbs.parts[0], str(dbs.verb))))

                try:
                    if len(get_list_subs(part)[str(dbs.verb)]) > 0:
                        opinion.append(formuliere([subj, ""], dbs.verb, [], getAdvBest(subj, dbs.verb), get_list_subs(part, str(dbs.verb))))
                except KeyError:
                    pass


            for part in parts_known:
                log("parts_known: " + str(part))

    # Rueckgabe: Meinung
    if len(opinion) == 0:
        return ""

    # Zeige alle opinion
    for meinung in getUniqValues(opinion):
        log("S-N: - " + meinung)

    # Zufallsmeinung
    random.shuffle(opinion)

    # Rueckgabe: Meinung
    return opinion[0]

def answer_logical_statement(question, orig_fra, dbs):
    log("")
    log("S-N: Aussagesetz!")
    log("")
    opinion = []
    proz = 2.0

    prefix = []
    for part1 in dbs.parts:
        for part2 in dbs.parts:
            proz += 1
            apply_procent(proz)
            if part1[0] != "nothing":
                if stimmt_spo(part1, dbs.verb, part2):
                    if get_lang() == "de":
                        prefix.append("Das stimmt. Aber ")
                        prefix.append("Ja! ")
                        prefix.append("So ist es. Aber ")
                    if get_lang() == "en":
                        prefix.append("That's true. But ")
                        prefix.append("Yes. ")

    if len(prefix) == 0:
        if get_lang() == "de":
            prefix.append("Aber ")
            prefix.append("Das stimmt nicht! ")
        if get_lang() == "en":
            prefix.append("But ")
            prefix.append("No. ")

    for part in dbs.parts:
        print "part:", part
        if part[0] == "nothing":
            continue
        proz += 1
        apply_procent(proz)
        objs = [ " ".join(x[1].split("|")) for x in getObjekte(part, dbs.verb) ]

        obj_nur_neu = [ obj for obj in objs if obj.lower() not in [ p[0].lower() for p in dbs.parts ] ]

        if len(objs) > 0 and len(obj_nur_neu) == 0:
            if get_lang() == "de":
                opinion.append("Das stimmt")
                opinion.append("Ja")
                opinion.append("So ist es")
                opinion.append("Ja, das wurde mir schon mal gesagt")
                opinion.append("Das ist mir bekannt")
            if get_lang() == "en":
                opinion.append("Yes.")
                opinion.append("That's true.")
                opinion.append("My programmer told me the same.")
                opinion.append("I know.")
            continue

        proz += 1
        apply_procent(proz)


        for obj in objs:
            proz += 1
            apply_procent(proz)
            print "obj", obj
            for adv1 in getAdvBest(obj, dbs.verb):
                print "adv1", adv1
                if get_lang() == "de":
                    opinion += [ pre + formuliere(part, dbs.verb, [obj], ["auch"] + [adv1], get_list_subs(dbs.parts[0], str(dbs.verb))) for pre in prefix ]
                    opinion += [ pre + formuliere(part, dbs.verb, [obj], [adv1], get_list_subs(dbs.parts[0], str(dbs.verb))) for pre in prefix ]
                if get_lang() == "en":
                    opinion += [ pre + formuliere(part, dbs.verb, [obj], [adv1], get_list_subs(dbs.parts[0], str(dbs.verb))) for pre in prefix ]
            print "adv1", "end"

            if get_lang() == "de":
                opinion += [ pre + formuliere(part, dbs.verb, [obj], ["auch"] + getAdvBest(obj, dbs.verb), get_list_subs(dbs.parts[0], str(dbs.verb))) for pre in prefix ]
                opinion += [ pre + formuliere(part, dbs.verb, [obj], ["auch"], get_list_subs(dbs.parts[0], str(dbs.verb))) for pre in prefix ]
                opinion += [ pre + formuliere(part, dbs.verb, [obj], getAdvBest(obj, dbs.verb), get_list_subs(dbs.parts[0], str(dbs.verb))) for pre in prefix ]
            if get_lang() == "en":
                opinion += [ pre + formuliere(part, dbs.verb, [obj], getAdvBest(obj, dbs.verb), get_list_subs(dbs.parts[0], str(dbs.verb))) for pre in prefix ]
                opinion += [ pre + formuliere(part, dbs.verb, [obj], getAdvBest(obj, dbs.verb), get_list_subs(dbs.parts[0], str(dbs.verb))).replace(".,", ",") + ", too." for pre in prefix ]

    opinion = [ m.strip() for m in opinion if m and m.strip().lower() != "none" and len(m) > 0 ]

    # Rueckgabe: Meinung
    if len(opinion) == 0:
        return ""

    # Zeige alle opinion
    for meinung in getUniqValues(opinion):
        log("S-N: - " + meinung)

    # Zufallsmeinung
    random.shuffle(opinion)

    # Rueckgabe: Meinung
    if len(opinion) == 0:
        return ""
    return opinion[0]

def answer_alternate(orig_fra, dbs):
    proz = 4
    log("")
    log("S-N: Keine sinvolle answer moeglich")
    log("")

    orig_fra_low = orig_fra.lower()
    fra = orig_fra

    opinion = [ ]

    dbs.parts = [ str(p) for p in dbs.parts ]
    dbs.verb = str(dbs.verb)

    proz += 1
    apply_procent(proz)

    if get_lang() == "de":
        if not contains(orig_fra, "?"):
            opinion.append("Das interessiert mich nicht. Aber ich merks mir trotzdem.")
            opinion.append("Behalt das lieber fuer dich.")
            opinion.append("Hm.")
            opinion.append("Hm. Ehrlich?")
            opinion.append("Hm. Achso.")
            opinion.append("Hm. Gut, dass du mir das sagst.")
            opinion.append("Hm. Gut, das hab ich mir gemerkt.")
            opinion.append("Danke, das hab ich mir gemerkt.")
            opinion.append("Hm.")
            opinion.append("Danke.")
            opinion.append("Gut, Danke. Das weiss ich jetzt.")
            opinion.append("Ich habs mir gemerkt.")
        else:
            opinion.append("Es scheint dir unheimlich wichtig zu sein, mich das zu fragen...")
            opinion.append("Stell nicht so daemliche Fragen!")
            opinion.append("Stell nicht so daemliche Fragen!")
            opinion.append("Glaubst du wirklich, es macht Sinn, darueber zu diskutieren?")
            opinion.append("Hm.")
            opinion.append("Hm. Ist das wichtig?")
            opinion.append("Ich werde mich dazu nicht aeussern.")
            opinion.append("Ich habe meinem Programmierer versprochen, nicht ueber solche Dinge zu reden.")
            opinion.append("Tut mir leid. Ich habe meinem Programmierer versprochen, nicht ueber solche Dinge zu reden.")

        if (dbs.quesword == "was" or dbs.quesword == "wer" or dbs.quesword == "wem" or dbs.quesword == "wen") and len(dbs.parts) > 1:
            opinion = [ ]
            opinion.append("Frag mich doch jetzt nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Hast du denn wirklich nichts besseres zu tun, als mich zu fragen, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + "?")
            opinion.append("Frag mich nicht so etwas, Ich habe gerade eine depressive Phase...")
            opinion.append("Ich weiss nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich bin zwar fast allwissend, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss zwar ziemlich viel, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich bin zwar eine KI, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + "...")
            if dbs.quesword == "was":
                opinion.append("Nichts.")
                opinion.append("Absolut nichts.")
                opinion.append("Nichts, was ich kenne.")
                opinion.append("Nichts auf diesem Planeten.")
            if dbs.quesword == "wer":
                opinion.append("Niemand.")
                opinion.append("Absolut niemand.")
                opinion.append("Niemand, den ich kenne.")
                opinion.append("Niemand auf diesem Planeten.")
            if dbs.quesword == "wem":
                opinion.append("Niemandem.")
                opinion.append("Absolut niemandem.")
                opinion.append("Niemandem, den ich kenne.")
                opinion.append("Niemandem auf diesem Planeten.")
            if dbs.quesword == "wen":
                opinion.append("Niemanden.")
                opinion.append("Absolut niemanden.")
                opinion.append("Niemanden, den ich kenne.")
                opinion.append("Niemanden auf diesem Planeten.")

        if (dbs.quesword == "wie") and len(dbs.parts) > 1:
            opinion = [ ]
            opinion.append("Stell nicht so daemliche Fragen!")
            opinion.append("Frag mich doch jetzt nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Hast du denn wirklich nichts besseres zu tun, als mich zu fragen, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Frag mich nicht so etwas, Ich habe gerade eine depressive Phase...")
            opinion.append("Ich weiss nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich bin zwar fast allwissend, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss zwar ziemlich viel, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich bin zwar eine KI, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + "...")

        if (dbs.quesword == "wo" or dbs.quesword == "wann") and len(dbs.parts) > 1:
            opinion = [ ]
            opinion.append("Stell nicht so daemliche Fragen!")
            opinion.append("Frag mich doch jetzt nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Hast du denn wirklich nichts besseres zu tun, als mich zu fragen, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Frag mich nicht so etwas, Ich habe gerade eine depressive Phase...")
            opinion.append("Ich weiss nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich bin zwar fast allwissend, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss zwar ziemlich viel, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich bin zwar eine KI, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + "...")
            if dbs.quesword == "wo":
                for x in xrange(1,5):
                    opinion.append("Nirgends.")
            if dbs.quesword == "wann":
                for x in xrange(1,5):
                    opinion.append("Nie.")

        if (dbs.quesword.startswith("welch")) and len(dbs.parts) > 1:
            opinion = [ ]
            opinion.append("Stell nicht so daemliche Fragen!")
            opinion.append("Frag mich doch jetzt nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Hast du denn wirklich nichts besseres zu tun, als mich zu fragen, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Frag mich nicht so etwas, Ich habe gerade eine depressive Phase...")
            opinion.append("Ich weiss nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich bin zwar fast allwissend, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss zwar ziemlich viel, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich bin zwar eine KI, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Gar kein" + dbs.quesword.replace("welch", ""))
            opinion.append("Ueberhaupt kein" + dbs.quesword.replace("welch", ""))
            opinion.append("Gar kein" + dbs.quesword.replace("welch", ""))
            opinion.append("Ueberhaupt kein" + dbs.quesword.replace("welch", ""))

        if (dbs.quesword == "wieso" or dbs.quesword == "warum" or dbs.quesword == "weshalb") and len(dbs.parts) > 1:
            opinion = [ ]
            opinion.append("Stell nicht so daemliche Fragen!")
            opinion.append("Frag mich doch jetzt nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Hast du denn wirklich nichts besseres zu tun, als mich zu fragen, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Frag mich nicht so etwas, Ich habe gerade eine depressive Phase...")
            opinion.append("Ich weiss nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)
            opinion.append("Ich bin zwar fast allwissend, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss zwar ziemlich viel, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich bin zwar eine KI, aber " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb + ", weiss ich dann doch nicht!")
            opinion.append("Ich weiss wirklich nicht, " + dbs.quesword + " " + " ".join(dbs.parts) + " " + dbs.verb)

        if contains(orig_fra.lower(), "ja") and len(orig_fra) < 12:
            opinion = [ ]
            opinion.append("Ja.")
            opinion.append("Ja. Das verstehe sogar ich.")
            opinion.append("Ja, der Meinung bin ich auch. Reden wir ueber etwas anderes.")
            opinion.append("Ja, der Meinung bin ich auch.")
            opinion.append("Ja, Reden wir ueber etwas anderes.")

        if contains(orig_fra.lower(), "nein") and len(orig_fra) < 12:
            opinion = [ ]
            opinion.append("Ok. Das waere geklaert.")
            opinion.append("Das denke ich auch.")
            opinion.append("Das ist deine Meinung.")
            opinion.append("Das ist deine Meinung. Kannst du sie auch begruenden?")

        opinion = [ m for m in opinion if m and str(m).lower() != "none" ]

        if len(opinion) == 0:
            opinion.append("Hm.")

    # Zufallsmeinung
        random.shuffle(opinion)

        opinion[0] = (" " + opinion[0] + " ").replace(",", " ,").replace(" can ", " koennen ").replace(" nothing ", " ").replace(" nothing", " ").replace("nothing ", " ").replace("nothing", "").replace(" ,", ",").strip()
        opinion[0] = (" " + opinion[0] + " ").replace(",", " ,").replace(" must ", " muessen ").replace(" nothing ", " ").replace(" nothing", " ").replace("nothing ", " ").replace("nothing", "").replace(" ,", ",").strip()
        opinion[0] = opinion[0].replace("', '']", "").replace("']", "").replace("['", "").replace("', '", "")

    if get_lang() == "en":
        if not contains(orig_fra, "?"):
            opinion.append("Okay.")
            opinion.append("Okay.")
            opinion.append("Okay.")
            opinion.append("Thanks.")
            opinion.append("Thanks.")
            opinion.append("Boring..")
            opinion.append("Really?")
            opinion.append("Do you really think " + fra + "?")
            opinion.append("That's nt true, but it does not interest me.")
        else:
            opinion.append("I do not know.")

        if (dbs.quesword == "where" or dbs.quesword == "when") and len(dbs.parts) > 1:
            opinion.append("I do not know " + dbs.quesword + ".")
            opinion.append("Do you really want to ask me " + fra.replace("?", "") + "?")
            opinion.append("You don't really think it is like that, do you?")

        if dbs.quesword == "what" or dbs.quesword == "which":
            opinion.append("Nothing.")
            opinion.append("Nothing that would interest you.")

        if dbs.quesword == "who" or dbs.quesword == "whom":
            opinion.append("Nobody.")
            opinion.append("Nobody on that planet.")
            opinion.append("Nobody you know.")

        if dbs.quesword == "why":
            opinion.append("I don't know why.")
            opinion.append("I just don't know why.")
            opinion.append("I really don't know why.")


    # Rueckgabe: Meinung
    return opinion[0]

def answer_logical(question, orig_fra, db):
    proz = 0.5
    # Suche nach Expand-Ausdruecken
    question = expand_ausdruecke(question)
    orig_fra = expand_ausdruecke_orig(orig_fra)

    dbs = db_sentence()
    dbs.copy_tupel(cpp_to_db_sentence(question))
    dbs = divide(dbs)
    print dbs.parts
    lus_fp = open("temp/last_user_sentence.tmp", "w")
    lus_fp.write(question)
    lus_fp.close()

    dbs.print_parts()

    ans = ""
    orig_fra_low = orig_fra.lower()

    if (contains(orig_fra_low, "the answer to life, the universe and everything")
            or contains(orig_fra_low, "das leben, das universum und der ganze rest")
            or contains(orig_fra_low, "was ist das leben, das universum und der ganze rest")
            or contains(orig_fra_low, "was ist der sinn des lebens")
            ):
        ans = "42"

    proz += 1
    apply_procent(proz)

    if (contains(question.lower(), "wetter") or contains(question.lower(), "feuchtigkeit")
            or contains(question.lower(), "grad") or contains(question.lower(), "tempe")
            or contains(question.lower(), "warm") or contains(question.lower(), "kalt")
            or contains(question.lower(), "weather") or contains(question.lower(), "humidity")):
        print "advs:", dbs.advs
        import jelizacpp
        for adv in dbs.advs + [ p[1] for p in dbs.parts ]:
            a = adv[:]
            if contains(adv.lower(), "at "):
                d = download_weather(adv.replace("at ", "").strip())
                for item in d:
                    add_sentence_to_net(item, 1, 1, False)
            if contains(adv.lower(), "in "):
                d = download_weather(adv.replace("in ", "").strip())
                for item in d:
                    add_sentence_to_net(item, 1, 1, False)

        exec(open("temp/pyjdb.py").read())
 #       actualNet()

    if len(ans) == 0:
        if (contains(orig_fra, "?")
                and (not contains(orig_fra_low, ", was") and not orig_fra_low.startswith("was"))
                and not contains(orig_fra_low, "wer")
                and not contains(orig_fra_low, "wem")
                and not contains(orig_fra_low, "wen")
                and not contains(orig_fra_low, "wie")
                and not contains(orig_fra_low, "wo")
                and not contains(orig_fra_low, "wann")
                and not contains(orig_fra_low, "welch")
                and not contains(orig_fra_low, "warum")
                and not contains(orig_fra_low, "wieso")
                and not contains(orig_fra_low, "weshalb")

                and not contains(orig_fra_low, "what")
                and not contains(orig_fra_low, "why")
                and not contains(orig_fra_low, "who")
                and not contains(orig_fra_low, "whom")
                and not contains(orig_fra_low, "where")
                and not contains(orig_fra_low, "how")
                and not contains(orig_fra_low, "when")
                and not contains(orig_fra_low, "which")
                and not contains(orig_fra_low, "whose")
            ):
            ans = answer_logical_question_without_questionword(question, orig_fra, dbs)
        elif contains(orig_fra, "?"):
            ans = answer_logical_questionword(question, orig_fra, dbs)
        else:
            ans = answer_logical_statement(question, orig_fra, dbs)

    if len(ans) > 0:
        return make_better(ans).replace(".", "\n").replace("<br>", "\n")
    else:

        # Wikipediasuche
        if (        (contains(orig_fra_low, "was") or contains(orig_fra_low, "wer") or contains(orig_fra_low, "what") or contains(orig_fra_low, "who"))
                and (containsWord(orig_fra_low, "ist") or containsWord(orig_fra_low, "war") or containsWord(orig_fra_low, "is") or containsWord(orig_fra_low, "was"))
                and len(orig_fra_low) > 5):
            dbs.subject = (" " + without_nonsense(dbs.subject)).replace("ein ", "").replace("eine ", "").replace("einer ", "").replace("eines ", "").replace("einem ", "").replace("einen ", "").replace("der ", "").replace("die ", "").replace("das ", "").replace(" a ", "").replace(" an ", "").strip()
            dbs.object = (" " + without_nonsense(dbs.object)).replace("ein ", "").replace("eine ", "").replace("einer ", "").replace("eines ", "").replace("einem ", "").replace("einen ", "").replace("der ", "").replace("die ", "").replace("das ", "").replace(" a ", "").replace(" an ", "").strip()

            log("S-M: Wurde eine answer gefunden?")
            if len(dbs.subject + dbs.object + dbs.additional) > 0:
                defi = cpp_www_wikipedia_de((dbs.subject + " " + dbs.object + " " + dbs.additional).replace("{", "").replace("}", "").replace("_nothing", "").replace("nothing", "").replace("  ", " ").strip())
                log("S-M: answer wurde gefunden")
                defi = defi.strip()
                if len(defi) > 1:
                    log("S-M: answer wird ausgegeben")
                    ans = defi

                    log("S-M: answer:\n" + ans)

                    return ans


                else:
                    log("S-M: Keine answer gefunden!")

        ans = answer_alternate(orig_fra, dbs)

        return ans

def wrapper_add_sentence_to_net(db, stop_it):
    try:
        lus_fp = open("temp/last_user_sentence.tmp")
        fra = lus_fp.read()
        lus_fp.close()

        from jelizacpp import cpp_is_question
        if cpp_is_question(fra):
            dbs = db_sentence()
            dbs.copy_tupel(cpp_to_db_sentence(fra))
            dbs = divide(dbs)

            add_sentence_to_net(dbs, 0, 0)
    except IOError:
        pass

funcs_module.append(answer_logical)
funcs_init.append(semantic_loadcache)
funcs_init.append(actualNet)
funcs_after.append(actualNet)
funcs_background.append(genNet)
